Index: Singular/LIB/monomial.lib
===================================================================
--- Singular/LIB/monomial.lib	(revision 7f8587b3752e6d6a92df017bafdfb3d03198e66b)
+++ Singular/LIB/monomial.lib	(revision abbd22e3508e31d6abd926f194f4cb62f9365784)
@@ -3100,25 +2965,24 @@
 static proc divide (intvec v, intvec w, int k)
 {
-  def R = basering;
-  int nvar = nvars(R);
+  int nvar = nvars(basering);
   // Variables
   int i;
-  for (i = 1 ; i <= nvar ; i ++)
-    {
-      if (i == k)
-        {
-          if (v[i] <> w[i])
-            {
-              return (0);
-            }
-        }
-      else
-        {
-          if (v[i] >= w[i])
-            {
-              return (0);
-            }
-        }
-    }
+  for (i = nvar ; i > 0 ; i --)
+  {
+    if (i == k)
+    {
+      if (v[i] <> w[i])
+      {
+        return (0);
+      }
+    }
+    else
+    {
+      if (v[i] >= w[i])
+      {
+        return (0);
+      }
+    }
+  }
   return (1);
 }
@@ -3129,9 +2993,5 @@
 static proc incrementalAlg (ideal I)
 {
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
-  ideal I = fetch(R,I);
+  int nvar = nvars(basering);
   // COMPROBACIONES
   // Variables
@@ -3143,13 +3003,13 @@
   ideal artI;
   if (artiniano[1] == 0)
-    {
-      artI = artiniano[2];
-      elimina = artiniano[3];
-    }
+  {
+    artI = artiniano[2];
+    elimina = artiniano[3];
+  }
   else
-    {
-      artI = I;
-      elimina[nvar] = 0;
-    }
+  {
+    artI = I;
+    elimina[nvar] = 0;
+  }
   // Buscamos la primera componente irreducible o, lo que es lo
   // mismo, aquellos generadores que son potencia de una variable.
@@ -3158,55 +3018,55 @@
   // ideal.
   list MinI,componentes;
-  int sizartI = size(artI);
+  int sizartI = ncols(artI);
   int sizelimina = size(elimina);
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      if (elimina[i] == 0)
-        {
-          // Buscamos en el ideal los generadores que nos interesan
-          for (j = 1 ; j <= sizartI ; j ++)
+  {
+    if (elimina[i] == 0)
+    {
+      // Buscamos en el ideal los generadores que nos interesan
+      for (j = 1 ; j <= sizartI ; j ++)
+      {
+        sop = soporte(artI[j]);
+        if (sop <> 0)
+        {
+          beta[sop] = leadexp(artI[j])[sop];
+          MinI = insert(MinI,leadexp(artI[j]));
+          if (j <> 1 and j <> sizartI)
+          {
+            artI = artI[1..j - 1],artI[j + 1..sizartI];
+          }
+          else
+          {
+            if (j == 1)
             {
-              sop = soporte(artI[j]);
-              if (sop <> 0)
-                {
-                  beta[sop] = leadexp(artI[j])[sop];
-                  MinI = insert(MinI,leadexp(artI[j]));
-                  if (j <> 1 and j <> sizartI)
-                    {
-                      artI = artI[1..j - 1],artI[j + 1..sizartI];
-                    }
-                  else
-                    {
-                      if (j == 1)
-                        {
-                          artI = artI[2..sizartI];
-                        }
-                      else
-                        {
-                          artI = artI[1..sizartI - 1];
-                        }
-                    }
-                  sizartI = size(artI);
-                  break;
-                }
+              artI = artI[2..sizartI];
             }
-        }
-      else
-        {
-          // Buscamos la que esta al final
-          sop = soporte(artI[sizartI]);
-          beta[sop] = leadexp(artI[sizartI])[sop];
-          MinI = insert(MinI,leadexp(artI[sizartI]));
-          if (sizartI <> 1)
+            else
             {
               artI = artI[1..sizartI - 1];
             }
-          else
-            {
-              artI = artI[1];
-            }
-          sizartI = size(artI);
-        }
-    }
+          }
+          sizartI = ncols(artI);
+          break;
+        }
+      }
+    }
+    else
+    {
+      // Buscamos la que esta al final
+      sop = soporte(artI[sizartI]);
+      beta[sop] = leadexp(artI[sizartI])[sop];
+      MinI = insert(MinI,leadexp(artI[sizartI]));
+      if (sizartI <> 1)
+      {
+        artI = artI[1..sizartI - 1];
+      }
+      else
+      {
+        artI = artI[1];
+      }
+      sizartI = ncols(artI);
+    }
+  }
   // En beta tenemos la primera componente
   componentes = insert(componentes,beta);
@@ -3219,105 +3079,105 @@
   intvec expartI;
   for(i = 1 ; i <= sizartI ; i ++)
-    {
-      expartI = leadexp(artI[1]);
-      if (size(artI) <> 1)
-        {
-          artI = artI[2..size(artI)];
-        }
-      // Hay que distinguir T_1 y T_2. Para ello se comparar vectores
-      // de la lista actual de generadores con el que se acaba de
-      // introducir.
-      cont2 = 0;
-      for (j = 1 ; j <= sizcomponents ; j ++)
-        {
-          beta = componentes[1 + cont2];
-          // Si el nuevo generador divide a la componente beta, hay
-          // que buscar las nuevas componentes
-          for (k = 1 ; k <= nvar ; k ++)
+  {
+    expartI = leadexp(artI[1]);
+    if (size(artI) <> 1)
+    {
+      artI = artI[2..size(artI)];
+    }
+    // Hay que distinguir T_1 y T_2. Para ello se comparar vectores
+    // de la lista actual de generadores con el que se acaba de
+    // introducir.
+    cont2 = 0;
+    for (j = 1 ; j <= sizcomponents ; j ++)
+    {
+      beta = componentes[1 + cont2];
+      // Si el nuevo generador divide a la componente beta, hay
+      // que buscar las nuevas componentes
+      for (k = 1 ; k <= nvar ; k ++)
+      {
+        if (expartI[k] >= beta[k])
+        {
+          break;
+        }
+      }
+      // Si el bucle anterior termino, divide y hay que hacer
+      // los cambios.
+      if (k == nvar + 1)
+      {
+        componentes = delete (componentes,1 + cont2);
+        // Buscamos las nuevas componentes calculando las
+        // distancias. Para cada variable busco d(beta,k,l)
+        for (k = 1 ; k <= nvar ; k ++)
+        {
+          betaaux = beta;
+          max = -1;
+          cont = 0;
+          dbeta = 0;
+          for (l = 1 ; l <= nvar ; l ++)
+          {
+            if (l <> k)
             {
-              if (expartI[k] >= beta[k])
+              min = 32767;
+              cont ++;
+              for (m = 1 ; m <= sizMin ; m ++)
+              {
+                // Estos son de los buenos
+                if (divide(MinI[m],beta,l) == 1)
                 {
-                  break;
+                  if (MinI[m][k] < min)
+                  {
+                    min = MinI[m][k];
+                  }
                 }
+              }
+              dbeta[cont] = min;
             }
-          // Si el bucle anterior termino, divide y hay que hacer
-          // los cambios.
-          if (k == nvar + 1)
+          }
+          // Aqui ya tenemos d(beta,k,l) para cada k
+          // Hallamos el maximo cuando terminemos
+          for (l = 1 ; l <= cont ; l ++)
+          {
+            if (dbeta[l] > max)
             {
-              componentes = delete (componentes,1 + cont2);
-              // Buscamos las nuevas componentes calculando las
-              // distancias. Para cada variable busco d(beta,k,l)
-              for (k = 1 ; k <= nvar ; k ++)
-                {
-                  betaaux = beta;
-                  max = -1;
-                  cont = 0;
-                  dbeta = 0;
-                  for (l = 1 ; l <= nvar ; l ++)
-                    {
-                      if (l <> k)
-                        {
-                          min = 32767;
-                          cont ++;
-                          for (m = 1 ; m <= sizMin ; m ++)
-                            {
-                              // Estos son de los buenos
-                              if (divide(MinI[m],beta,l) == 1)
-                                {
-                                  if (MinI[m][k] < min)
-                                    {
-                                      min = MinI[m][k];
-                                    }
-                                }
-                            }
-                          dbeta[cont] = min;
-                        }
-                    }        
-                  // Aqui ya tenemos d(beta,k,l) para cada k
-                  // Hallamos el maximo cuando terminemos
-                  for (l = 1 ; l <= cont ; l ++)
-                    {
-                      if (dbeta[l] > max)
-                        {
-                          max = dbeta[l];
-                        }
-                    }
-                  // Condicion para introducir nueva componente
-                  if (max < expartI[k])
-                    {
-                      betaaux[k] = expartI[k];
-                      componentes = insert(componentes,betaaux,size(componentes));
-                    }
-                }
+              max = dbeta[l];
             }
-          else
-            {
-              cont2 ++;
-            }
-        }
-      MinI = insert(MinI,expartI);
-      sizMin = size(MinI);
-      sizcomponents = size(componentes);
-    }
+          }
+          // Condicion para introducir nueva componente
+          if (max < expartI[k])
+          {
+            betaaux[k] = expartI[k];
+            componentes = insert(componentes,betaaux,size(componentes));
+          }
+        }
+      }
+      else
+      {
+        cont2 ++;
+      }
+    }
+    MinI = insert(MinI,expartI);
+    sizMin = size(MinI);
+    sizcomponents = size(componentes);
+  }
   // Deahacer los cambios de artiniano si se han hecho
   if (artiniano[1] == 0)
-   {
-     // En elimina tenemos las variables que hemos introducido
-     // y cual es la potencia
-     // Solo miro las que tengan cambio
-     for (i = 1 ; i <= nvar ; i ++)
-       {
-         if (elimina[i] <> 0)
-           {
-             for (j = 1 ; j <= sizcomponents ; j ++)
-               {
-                 if (componentes[j][i] == elimina[i])
-                   {
-                     componentes[j][i] = 0;
-                   }
-               }
-           }
-       }
-   }
+  {
+    // En elimina tenemos las variables que hemos introducido
+    // y cual es la potencia
+    // Solo miro las que tengan cambio
+    for (i = 1 ; i <= nvar ; i ++)
+    {
+      if (elimina[i] <> 0)
+      {
+        for (j = 1 ; j <= sizcomponents ; j ++)
+        {
+          if (componentes[j][i] == elimina[i])
+          {
+            componentes[j][i] = 0;
+          }
+        }
+      }
+    }
+  }
   // En exp(i) tengo los exponentes de cada variable de las que aparecen
   // en cada ideal.
@@ -3325,19 +3185,16 @@
   list facets;
   for (i = 1 ; i <= sizcomponents ; i ++)
-    {
-      J = 0;
-      for (j = 1 ; j <= nvar ; j ++)
-        {
-          if (componentes[i][j] <> 0)
-            {
-              J = J,x(j)^componentes[i][j];
-            }
-        }
-      J = simplify(J,2);
-      facets[i] = J;
-    }
-  setring R;
-  list facets = fetch (R1,facets);
-  kill R1;
+  {
+    J = 0;
+    for (j = 1 ; j <= nvar ; j ++)
+    {
+      if (componentes[i][j] <> 0)
+      {
+        J = J,var(j)^componentes[i][j];
+      }
+    }
+    J = simplify(J,2);
+    facets[i] = J;
+  }
   return (facets);
 }
@@ -3364,16 +3221,16 @@
 static proc divideMon (poly f , poly g)
 {
-  def R = basering;
-  int nvar = nvars(R);
-  intvec expf = leadexp(f);
-  intvec expg = leadexp(g);
-  for (int i = 1 ; i <= nvar ; i ++)
-    {
-      if (expf[i] > expg[i])
-        {
-          return (0);
-        }
-    }
-  return (1);
+  return (lead(g)/lead(f)!=0);
+  //int nvar = nvars(basering);
+  //intvec expf = leadexp(f);
+  //intvec expg = leadexp(g);
+  //for (int i = 1 ; i <= nvar ; i ++)
+  //{
+  //  if (expf[i] > expg[i])
+  //  {
+  //    return (0);
+  //  }
+  //}
+  //return (1);
 }
 //////////////////////////////////////////////////////////////////////
@@ -3382,9 +3239,6 @@
 {
   // I is monomial ideal
-  def R = basering;
-  I = fetch (R,I);
-  S = fetch(R,S);
-  int sizI = size(I);
-  int nvar = nvars(R);
+  int sizI = ncols(I);
+  int nvar = nvars(basering);
   intvec explcmMin = leadexp(lcmMin);
   // Variables
@@ -3395,52 +3249,52 @@
   intvec xiexp;
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      if (explcmMin[i] >= 2 )
-        {
-          // Median exponent of x(i) from intersection(minI,x(i))
-          cont = 0;
-          for (j = 1 ; j <= sizI ; j ++)
-            {
-              exp = leadexp(I[j])[i];
-              if (exp > 0)
-                {
-                  cont ++;
-                  xiexp[cont] = exp;
-                }
-            }
-          xiexp = sort(xiexp)[1];
-          sizxi = size(xiexp);
-          if (size(xiexp) == 1)
-            {
-              median = xiexp[1] - 1;
-            }
-          else
-            {
-              if (size(xiexp) == 2)
-                {
-                  median = xiexp[2] - 1;
-                }
-              else
-                {
-                  median = xiexp[(size(xiexp) + 1) / 2];
-                }
-            }
-          p = x(i)^median;
-          // valid pivot??
-          if ( membershipMon(p,S) == 0)
-            {
-              return(p);
-            }
-          else
-            {
-              max = maximoExp(S,i);
-              if ( xiexp[sizxi] == max )
-                {
-                  return(x(i)^(max-1));
-                }
-            }
-          xiexp = 0;
-        }
-    }
+  {
+    if (explcmMin[i] >= 2 )
+    {
+      // Median exponent of x(i) from intersection(minI,x(i))
+      cont = 0;
+      for (j = 1 ; j <= sizI ; j ++)
+      {
+        exp = leadexp(I[j])[i];
+        if (exp > 0)
+        {
+          cont ++;
+          xiexp[cont] = exp;
+        }
+      }
+      xiexp = sort(xiexp)[1];
+      sizxi = size(xiexp);
+      if (size(xiexp) == 1)
+      {
+        median = xiexp[1] - 1;
+      }
+      else
+      {
+        if (size(xiexp) == 2)
+        {
+          median = xiexp[2] - 1;
+        }
+        else
+        {
+          median = xiexp[(size(xiexp) + 1) / 2];
+        }
+      }
+      p = var(i)^median;
+      // valid pivot??
+      if ( membershipMon(p,S) == 0)
+      {
+        return(p);
+      }
+      else
+      {
+        max = maximoExp(S,i);
+        if ( xiexp[sizxi] == max )
+        {
+          return(var(i)^(max-1));
+        }
+      }
+      xiexp = 0;
+    }
+  }
 }
 //////////////////////////////////////////////////////////////////////
@@ -3451,13 +3305,11 @@
   int i, j, k, cont, numdeleted;
   intvec isMaximal;
-  def R = basering;
-  I = fetch(R,I);
-  int sizI = size(I);
-  int nvar = nvars(R);
+  int sizI = ncols(I);
+  int nvar = nvars(basering);
   poly lcmMinI = 1;
   for (i = 1 ; i <= sizI ; i ++)
-    {
-      lcmMinI = lcmMon(I[i],lcmMinI);
-    }
+  {
+    lcmMinI = lcmMon(I[i],lcmMinI);
+  }
   intvec explcmMinI = leadexp(lcmMinI);
   // Buscamos los elementos que son x(i) maximales. En caso de que
@@ -3466,55 +3318,54 @@
   isMaximal[sizI] = 0;
   intvec genexp;
-   for (i = 1 ; i <= sizI ; i ++)
-    {
-      genexp = leadexp(I[i]);
-      cont = 0;
-      for ( j = 1 ; j <= nvar ; j ++)
-        {
-          if (genexp[j] <> 0 && genexp[j] == explcmMinI[j])
+  for (i = 1 ; i <= sizI ; i ++)
+  {
+    genexp = leadexp(I[i]);
+    cont = 0;
+    for ( j = 1 ; j <= nvar ; j ++)
+    {
+      if (genexp[j] <> 0 && genexp[j] == explcmMinI[j])
+      {
+        if (cont == 0)
+        {
+          cont ++;
+          isMaximal[i] = j;
+        }
+        else
+        {
+          // Porque cuando encontramos que era maximal para
+          // la primera variable, lo guardamos
+          isMaximal[i] = 0;
+          // Eliminamos del ideal
+          if (i <> 1 && i <> sizI)
+          {
+            I = I[1..i - 1],I[i + 1..sizI];
+          }
+          else
+          {
+            if (i == 1)
             {
-        
-              if (cont == 0)
-                {
-                  cont ++;
-                  isMaximal[i] = j;
-                }
-              else
-                {
-                  // Porque cuando encontramos que era maximal para
-                  // la primera variable, lo guardamos
-                  isMaximal[i] = 0;
-                  // Eliminamos del ideal
-                  if (i <> 1 && i <> sizI)
-                    {
-                      I = I[1..i - 1],I[i + 1..sizI];
-                    }
-                  else
-                    {
-                      if (i == 1)
-                        {
-                          I = I[2..sizI];
-                        }
-                      else
-                        {
-                          I = I[1..sizI - 1];
-                        }
-                    }
-                  i --;
-                  sizI = size(I);
-                  // Generador i eliminado, miramos el siguiente
-                  break;
-                }
+              I = I[2..sizI];
             }
-        }
-    }
+            else
+            {
+              I = I[1..sizI - 1];
+            }
+          }
+          i --;
+          sizI = ncols(I);
+          // Generador i eliminado, miramos el siguiente
+          break;
+        }
+      }
+    }
+  }
    // En isMaximal[i] tenemos 0 si I[i] no es maximal,
-   // y j si I[i] es maximal en x(j).                                        
+   // y j si I[i] es maximal en x(j).
   // Matriz de exponentes de los generadores del ideal
   intmat expI[sizI][nvar];
   for (i = 1 ; i <= sizI ; i++)
-    {
-      expI[i,1..nvar] = leadexp(I[i]);
-    }
+  {
+    expI[i,1..nvar] = leadexp(I[i]);
+  }
   // Buscamos ahora cota inferior
   poly lcmMi = 1;
@@ -3522,46 +3373,46 @@
   intvec Mi, mincol,expgcd;
   for (i = 1 ; i <= nvar ; i ++)
-    {
-      Mi = 0;
-      cont = 0;
-      for (j = 1 ; j <= sizI ; j ++)
-        {
-          // De isMaximal solo se usan las entradas que se corresponden con elementos del ideal
-          if (expI[j,i] <> 0)
-            {
-              if (isMaximal[j] == 0 or isMaximal[j] == i)
-                {
-                  // Elementos del sistema minimal que estan
-                  // en Mi
-                  cont ++;
-                  Mi[cont] = j;
-                }
-            }
-        }
-      // Si solo hay un elemento en Mi, no hay nada que hacer
-      if (cont > 1)
-        {
-          gcdMi = I[Mi[1]];
-          // Tenemos los generadores a los que hay que hallar el gcd
-          for (j = 2; j <= cont ; j ++)
-            {
-              gcdMi = gcdMon(gcdMi,I[Mi[j]]);
-            }
-        }
+  {
+    Mi = 0;
+    cont = 0;
+    for (j = 1 ; j <= sizI ; j ++)
+    {
+      // De isMaximal solo se usan las entradas que se corresponden con elementos del ideal
+      if (expI[j,i] <> 0)
+      {
+        if (isMaximal[j] == 0 or isMaximal[j] == i)
+        {
+          // Elementos del sistema minimal que estan
+          // en Mi
+          cont ++;
+          Mi[cont] = j;
+        }
+      }
+    }
+    // Si solo hay un elemento en Mi, no hay nada que hacer
+    if (cont > 1)
+    {
+      gcdMi = I[Mi[1]];
+      // Tenemos los generadores a los que hay que hallar el gcd
+      for (j = 2; j <= cont ; j ++)
+      {
+        gcdMi = gcd(gcdMi,I[Mi[j]]);
+      }
+    }
+    else
+    {
+      if (Mi <> 0)
+      {
+        gcdMi = I[Mi[1]];
+      }
       else
-        {
-          if (Mi <> 0)
-            {
-              gcdMi = I[Mi[1]];
-            }
-          else
-            {
-              // Falta alguna variable
-              return (0,I);
-            }
-        }
-      l = gcdMi/x(i);
-      lcmMi = lcmMon(lcmMi,l);
-    }
+      {
+        // Falta alguna variable
+        return (0,I);
+      }
+    }
+    l = gcdMi/var(i);
+    lcmMi = lcmMon(lcmMi,l);
+  }
   // Ahora devolvemos la cota inferior, que luego hay que multiplicar
   // por el monomio que define el corte.
@@ -3573,107 +3424,103 @@
 static proc con (ideal I , ideal S , poly q)
 {
-  def R = basering;
-  int nvar = nvars(R);
-  I = fetch(R,I);
-  S = fetch(R,S);
-  q = fetch(R,q);
+  int nvar = nvars(basering);
   // Variables
   int i;
   poly piI;
-  int sizI = size(I);
+  int sizI = ncols(I);
   // Simplification process
   poly p;
   list sol;
   while (1)
-    {
-      // (I,S,q) normal slice?
-      // Como cada vez que introducimos una cota inferior sabemos
-      // que la slice actual es la inner slice (la otra es vacio),
-      // hay que volver a verificar si es normal
-      if ( S <> 0 )
-        {
-          // m/rad(m) esta en S, para m generador minimal de I??
-          for (i = 1 ; i <= sizI ; i ++)
-            {        
-              piI = pi(I[i]);
-              if (membershipMon(piI,S) == 1)
-                {
-                  if (i == 1)
-                    {
-                      I = I[2..sizI];
-                    }
-                  else
-                    {
-                      if (i == sizI)
-                        {
-                          I = I[1..sizI - 1];
-                        }
-                      else
-                        {
-                          I = I[1..i - 1],I[i + 1..sizI];
-                        }
-                    }
-                  sizI = size(I);
-                  i --;
-                }
+  {
+    // (I,S,q) normal slice?
+    // Como cada vez que introducimos una cota inferior sabemos
+    // que la slice actual es la inner slice (la otra es vacio),
+    // hay que volver a verificar si es normal
+    if ( S <> 0 )
+    {
+      // m/rad(m) esta en S, para m generador minimal de I??
+      for (i = 1 ; i <= sizI ; i ++)
+      {
+        piI = pi(I[i]);
+        if (membershipMon(piI,S) == 1)
+        {
+          if (i == 1)
+          {
+            I = I[2..sizI];
+          }
+          else
+          {
+            if (i == sizI)
+            {
+              I = I[1..sizI - 1];
             }
-        }
-      // Buscamos cota inferior, y si es distinta de 1, simplificamos
-      sol = simplification(I);
-      p = sol[1];
-      if (p == 1)
+            else
+            {
+              I = I[1..i - 1],I[i + 1..sizI];
+            }
+          }
+          sizI = ncols(I);
+          i --;
+        }
+      }
+    }
+    // Buscamos cota inferior, y si es distinta de 1, simplificamos
+    sol = simplification(I);
+    p = sol[1];
+    if (p == 1)
+    {
+      break;
+    }
+    else
+    {
+      if (p == 0)
+      {
+        break;
+      }
+      else
+      {
+        if (membershipMon(p,I) == 1 )
         {
           break;
         }
-      else
-        {
-          if (p == 0)
-            {
-              break;
-            }
-          else
-            {
-              if (membershipMon(p,I) == 1 )
-                {
-                  break;
-                }
-            }
-        }
-      // Changing slice by simplification
-      I = sol[2];
-      I = minbase(quotient(I,p));
-      q = p*q;
-      S = minbase(quotient(S,p));
-      sizI = size(I);
-    }
-  sizI = size(I);
+      }
+    }
+    // Changing slice by simplification
+    I = sol[2];
+    I = minbase(quotient(I,p));
+    q = p*q;
+    S = minbase(quotient(S,p));
+    sizI = ncols(I);
+  }
+  sizI = ncols(I);
   // (I,S,q) base case?
   poly lcmMinI;
   lcmMinI = 1;
   for (i = 1 ; i <= sizI ; i ++)
-    {
-      lcmMinI = lcmMon(lcmMinI,I[i]);
-    }
+  {
+    lcmMinI = lcmMon(lcmMinI,I[i]);
+  }
   // a:b generates an intvec of length b with constant entries a
   intvec one = 1:nvar;
   if (divideMon(monomial(one),lcmMinI) == 0)
-   {
-     return (0);
-   }
+  {
+    return (0);
+  }
   if (equal(radicalMon(I),I) == 1)
-    {
-      if (equal(I, maxideal(1)) == 0)
-        {
-                return (0);
-              }
-       else
-         {
-          for (i = 1 ; i <= nvar ; i ++)
-            {
-              q = q * x(i);
-            }
-          return (q);
-        }
-    }
+  {
+    if (equal(I, maxideal(1)) == 0)
+    {
+      return (0);
+    }
+    else
+    {
+      for (i = 1 ; i <= nvar ; i ++)
+      {
+        q = q * var(i);
+      }
+      return (q);
+    }
+  }
   // Selecting pivot
   p = pivot(I,lcmMinI,S);
@@ -3689,11 +3536,6 @@
 static proc irredDecMonSlice (ideal I)
 {
-  // New ring
-  def R = basering;
-  int nvar = nvars(R);
-  string s = "ring R1 =",charstr(R),",x(1..nvar),dp;";
-  execute(s);
-  ideal I = fetch(R,I);
-  int sizI = size(I);
+  int nvar = nvars(basering);
+  int sizI = ncols(I);
   int i,j;
   // Artinian ideal
@@ -3701,25 +3543,22 @@
   list artinianization = artinian(I);
   if (artinianization[1] == 0)
-    {
-      artI = artinianization[2];
-    }
+  {
+    artI = artinianization[2];
+  }
   else
-    {
-      artI = I;
-    }
+  {
+    artI = I;
+  }
   // Easy case: 2 variables
   if (nvar == 2)
-    {
-      artI = sort(artI)[1];
-      int sizartI = size(artI);
-      for (i = 1 ; i <= sizartI - 1 ; i ++)
-        {
-          components[i] = x(1)^(leadexp[artI[i]][1])*x(2)^(leadexp[artI[i + 1]][2]);
-        }
-      setring R;
-      list components = fetch(R1,components);
-      kill R1;
-      return (components);
-    }
+  {
+    artI = sort(artI)[1];
+    int sizartI = size(artI);
+    for (i = 1 ; i <= sizartI - 1 ; i ++)
+    {
+      components[i] = var(1)^(leadexp[artI[i]][1])*var(2)^(leadexp[artI[i + 1]][2]);
+    }
+    return (components);
+  }
   ideal irredDec = con (artI,0,1);
   // Delelting zeros
@@ -3728,11 +3567,11 @@
   intvec elimina;
   if (artinianization[1] == 0)
-    {
-      elimina = artinianization[3];
-    }
+  {
+    elimina = artinianization[3];
+  }
   else
-    {
-      elimina = 0;
-    }
+  {
+    elimina = 0;
+  }
  // Each generator (monomial) corresponds to an ideal
   list components;
@@ -3742,34 +3581,31 @@
   ideal auxIdeal;
   for (i = 1 ; i <= sizIrred ; i ++)
-    {
-      comp = irredDec[i];
-      exp = leadexp(comp);
-      for (j = 1 ; j <= nvar ; j ++)
-        {
-          if (exp[j] <> 0)
-            {
-              if (elimina <> 0)
-                {
-                  if (exp[j] == elimina[j])
-                    {
-                      auxIdeal[j] = 0;
-                    }
-                  else
-                    {
-                      auxIdeal[j] = x(j)^exp[j];
-                    }
-                }
-              else
-                {
-                  auxIdeal[j] = x(j)^exp[j];
-                }
-            }
-        }
-      components[i] = simplify(auxIdeal,2);
-      auxIdeal = 0;
-    }
-  setring R;
-  list components = fetch(R1,components);
-  kill R1;
+  {
+    comp = irredDec[i];
+    exp = leadexp(comp);
+    for (j = 1 ; j <= nvar ; j ++)
+    {
+      if (exp[j] <> 0)
+      {
+        if (elimina <> 0)
+        {
+          if (exp[j] == elimina[j])
+          {
+            auxIdeal[j] = 0;
+          }
+          else
+          {
+            auxIdeal[j] = var(j)^exp[j];
+          }
+        }
+        else
+        {
+          auxIdeal[j] = var(j)^exp[j];
+        }
+      }
+    }
+    components[i] = simplify(auxIdeal,2);
+    auxIdeal = 0;
+  }
   return (components);
 }
@@ -3820,68 +3656,67 @@
   // que comprobar si el ideal es monomial.
   if (control == 0)
-    {
-      list isMon = isMonomialGB (I);
-      if (isMon[1] == 0)
-        {
-          ERROR ("the ideal is not monomial.");
-        }
-      else
-        {
-          I = isMon[2];
-          // Ya lo tenemos con los generadores minimales
-        }
-    }
+  {
+    list isMon = isMonomialGB (I);
+    if (isMon[1] == 0)
+    {
+      ERROR ("the ideal is not monomial.");
+    }
+    else
+    {
+      I = isMon[2];
+      // Ya lo tenemos con los generadores minimales
+    }
+  }
   else
-    {
-      // Generadores monomiales, hallamos sistema minimal
-      I = minbase(I);
-
-    }
+  {
+    // Generadores monomiales, hallamos sistema minimal
+    I = minbase(I);
+  }
   // Si el ideal es irreducible, devolvemos el mismo
   if (isirreducibleMon(I) == 1)
-    {
-      return (I);
-    }
- // Si no me han dado opcion, elijo una yo.
- if (size(#) == 1)
-   {
-     return (irredDec3(I));
-   }
+  {
+    return (I);
+  }
+  // Si no me han dado opcion, elijo una yo.
+  if (size(#) == 1)
+  {
+    return (irredDec3(I));
+  }
   // Leo la opcion y llamo al procedimiento oportuno
   else
-    {
-      if (#[2] == "vas")
-        {
-          return (irredDec1(I));
-        }
-      if (#[2] == "add")
-        {
-          return (irredDec3(I));
-        }
-      if (#[2] == "ad")
-        {
-          return (irredDec4(I));
-        }
-      if (#[2] == "for")
-        {
-          return (irredDec5(I));
-        }
-      if (#[2] == "mil")
-        {
-          return (ScarfMethod(I));
-        }
-      if (#[2] == "lr")
-        {
-          return (labelAlgorithm(I));
-        }
-      if (#[2] == "gz")
-        {
-          return (incrementalAlg(I));
-        }
-      if (#[2] == "sr")
-        {
-          return (irredDecMonSlice(I));
-        }
-    }
+  {
+    if (#[2] == "vas")
+    {
+      return (irredDec1(I));
+    }
+    if (#[2] == "add")
+    {
+      return (irredDec3(I));
+    }
+    if (#[2] == "ad")
+    {
+      return (irredDec4(I));
+    }
+    if (#[2] == "for")
+    {
+      return (irredDec5(I));
+    }
+    if (#[2] == "mil")
+    {
+      return (ScarfMethod(I));
+    }
+    if (#[2] == "lr")
+    {
+      return (labelAlgorithm(I));
+    }
+    if (#[2] == "gz")
+    {
+      return (incrementalAlg(I));
+    }
+    if (#[2] == "sr")
+    {
+      return (irredDecMonSlice(I));
+    }
+  }
 }
 example
